<?php

namespace Drupal\monarch_utilities\Utility;

trait FormDependencyTrait {

  /**
   * Add a dependency to the form.
   *
   * @param array $element
   *   THe form element.
   * @param string $dependee
   *   The name of the dependee element (field name or group name).
   * @param string $dependent
   *   The name of the dependant element (field name or group name).
   * @param string $state
   *   The state of the dependency
   * @param string $andor
   *   Whether to use and/or for multiple dependencies
   */
  protected function addDependency(array &$element, string $dependee, string $dependent, string $action = 'checked', $value = TRUE, string $state = 'visible', string $andor = 'or') {
    if (isset($element[$dependent])) {
      if (!isset($element[$dependent]['#attributes']['class']) || !in_array('form-wrapper', $element[$dependent]['#attributes']['class'])) {
        $element[$dependent]['#attributes']['class'][] = 'form-wrapper';
      }

      if (!isset($element[$dependent]['#attributes']['class']) || !in_array('js-form-wrapper', $element[$dependent]['#attributes']['class'])) {
        $element[$dependent]['#attributes']['class'][] = 'js-form-wrapper';
      }

      if (isset($element[$dependent]['#states'][$state]) && $andor == 'or') {
        $element[$dependent]['#states'][$state][] = 'or';
      }
      $element[$dependent]['#states'][$state][] = [
        ':input[name="' . $dependee . '"]' => [$action => $value],
      ];
    }
  }

}